# 
# patch "manager.c"
#  from [1e316d894412ee36337d979872b645bb4f1f87b9]
#    to [bc3ffe452fca179a3b3c0e852bc93a20e10532a4]
# 
--- manager.c
+++ manager.c
@@ -663,6 +663,7 @@
 	char *id = astman_get_header(m,"ActionID");
 	char *varval;
 	char *varval2=NULL;
+	char workspace[1024];
 
 	if (!strlen(name)) {
 		astman_send_error(s, m, "No channel specified");
@@ -678,8 +679,14 @@
 		astman_send_error(s, m, "No such channel");
 		return 0;
 	}
-	
-	varval=pbx_builtin_getvar_helper(c,varname);
+
+	/* check if we need to execute an ast_custom_function or simply get a variable */
+	if (strlen(varname) && (varname[strlen(varname) - 1] == ')')) {
+		varval = ast_func_read(c, varname, workspace, sizeof(workspace));
+	} else {
+		varval = pbx_builtin_getvar_helper(c,varname);
+	}
+
 	if (varval)
 		varval2 = ast_strdupa(varval);
 	if (!varval2)
@@ -816,8 +823,10 @@
 		return 0;
 	}
 	if (!ast_strlen_zero(priority) && (sscanf(priority, "%d", &pi) != 1)) {
-		astman_send_error(s, m, "Invalid priority\n");
-		return 0;
+		if ((pi = ast_findlabel_extension(NULL, context, exten, priority, NULL)) < 1) {
+			astman_send_error(s, m, "Invalid priority\n");
+			return 0;
+		}
 	}
 	chan = ast_get_channel_by_name_locked(name);
 	if (!chan) {
@@ -968,8 +977,10 @@
 		return 0;
 	}
 	if (!ast_strlen_zero(priority) && (sscanf(priority, "%d", &pi) != 1)) {
-		astman_send_error(s, m, "Invalid priority\n");
-		return 0;
+		if ((pi = ast_findlabel_extension(NULL, context, exten, priority, NULL)) < 1) {
+			astman_send_error(s, m, "Invalid priority\n");
+			return 0;
+		}
 	}
 	if (!ast_strlen_zero(timeout) && (sscanf(timeout, "%d", &to) != 1)) {
 		astman_send_error(s, m, "Invalid timeout\n");
